#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#define startscript "/usr/share/system-config-adsl/adsl_install"
#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include <stdio.h>
struct scdata {
	char username[255];
	char password[255];
	char modemtype[255];
	int vpi;
	int vci;
	char firmware[255];
};
struct scdata data;

void on_combo1_selection_received(GtkWidget * widget, gpointer user_data)
{

	if (!strcmp(gtk_entry_get_text(GTK_ENTRY(widget)), "Poland"))
		loadpoland(operators);
	if (!strcmp(gtk_entry_get_text(GTK_ENTRY(widget)), "France"))
		loadfrance(operators);
	if (!strcmp(gtk_entry_get_text(GTK_ENTRY(widget)), "Germany"))
		loadgermany(operators);
	if (!strcmp(gtk_entry_get_text(GTK_ENTRY(widget)), "Italy"))
		loaditaly(operators);
	if (!strcmp(gtk_entry_get_text(GTK_ENTRY(widget)), "Spain"))
		loadspain(operators);
}

gboolean
on_combo1_button_press_event(GtkWidget * widget,
			     GdkEventButton * event, gpointer user_data)
{

}

void
on_combo2_selection_received(GtkWidget * widget,
			     GtkSelectionData * data,
			     guint time, gpointer user_data)
{

}

gboolean
on_combo2_button_press_event(GtkWidget * widget,
			     GdkEventButton * event, gpointer user_data)
{

	return FALSE;
}

void on_button4_clicked(GtkButton * button, gpointer user_data)
{
	gtk_main_quit();
}

void on_button5_clicked(GtkButton * button, gpointer user_data)
{
	sprintf(data.firmware, "%s", gtk_file_chooser_get_filename(fcdialog));
	char cmdexec[512];
	sprintf(cmdexec, "%s %s %s %s %d %d %s", startscript, data.modemtype,
		data.username, data.password, data.vpi, data.vci,
		data.firmware);
	g_printf("%s\n", cmdexec);
	system(cmdexec);
	gtk_main_quit();
}

void on_button1_clicked(GtkButton * button, gpointer user_data)
{
	FILE *fp;
	char line[100];
	char tmp[100];
	char search[100];

	bzero(&data, sizeof(struct scdata));
	if (strstr(modemname, "Sagem")) {

		int i = system("rpm -q --whatprovides eagle-usb-tools");
		g_printf("VALUE %d\n", i);
		if (i != 0) {
			GtkWidget *msg = create_msg();
			gtk_widget_show(msg);
//                      gtk_main_quit();
		}

	}

	if (strstr(modemname, "Thomson")) {
		int i = system("rpm -q --whatprovides speedtouch");
		g_printf("VALUE %d\n", i);
		if (i != 0) {
			GtkWidget *msg = create_msg();
			gtk_widget_show(msg);
//                      gtk_main_quit();
		}

	}

	if (strcmp(gtk_entry_get_text(GTK_ENTRY(country)), "Poland")
	    && strcmp(gtk_entry_get_text(GTK_ENTRY(country)), "France")
	    && strcmp(gtk_entry_get_text(GTK_ENTRY(country)), "Germany")
	    && strcmp(gtk_entry_get_text(GTK_ENTRY(country)), "Italy")
	    && strcmp(gtk_entry_get_text(GTK_ENTRY(country)), "Spain")) {
		data.vpi =
		    atoi(gtk_entry_get_text
			 (GTK_ENTRY(GTK_COMBO(operators)->entry)));
		data.vci = atoi(gtk_entry_get_text(GTK_ENTRY(country)));
	} else {
		fp = fopen(CONFFILE, "r");
		if (fp == NULL) {
			perror("Unable to open configuration file");
			exit(-1);
		}

		sprintf(search, "operator=%s",
			gtk_entry_get_text(GTK_ENTRY
					   (GTK_COMBO(operators)->entry)));
		while (fgets(line, 100, fp)) {
			if (strstr(line, search)) {
				while (fgets(line, 100, fp)) {
					if (strstr(line, "[end")
					    || strstr(line, "operator="))
						break;;
					if (strstr(line, "vci=")) {

						memcpy(tmp, &4[line],
						       strlen(line) - 5);
						data.vci = atoi(tmp);
					}
					if (strstr(line, "vpi=")) {
						memcpy(tmp, &4[line],
						       strlen(line) - 5);
						data.vpi = atoi(tmp);
					}

				}

			}

		}
	}
	if (strstr(modemname, "Sagem"))
		sprintf(data.modemtype, "sagem");
	if (strstr(modemname, "Thomson"))
		sprintf(data.modemtype, "speedtouch");
	sprintf(data.username, gtk_entry_get_text(GTK_ENTRY(user)));
	sprintf(data.password, gtk_entry_get_text(GTK_ENTRY(passwd)));

	if (strstr(modemname, "Thomson")) {
		fcdialog = create_filechooserdialog1();
		gtk_widget_show(fcdialog);
	} else {
		char cmdexec[512];
		sprintf(cmdexec, "%s %s %s %s %d %d", startscript,
			data.modemtype, data.username, data.password,
			data.vci, data.vpi);
		g_printf("%s\n", cmdexec);
		system(cmdexec);
		gtk_main_quit();
	}

}

void on_button2_clicked(GtkButton * button, gpointer user_data)
{
	gtk_main_quit();
}

void on_button3_clicked(GtkButton * button, gpointer user_data)
{
	gtk_main_quit();
}
